//rozrani obecneho (ne)orientovaneho (ne)ohodnoceneho grafu
// s moznosti vice (ne)ohodnocenych (ne)orientovanych hran mezi stejnymi uzly


#ifndef __GRAPH__H
#define __GRAPH__H

#include <set>

//////////////////////////////////////////////////////////////////////////////


class elem_t {                        // element grafu (dedi uzel a hrana)
   int value;                         // ohodnoceni, cena
  public:
   elem_t(int Value);                 // konstruktor
   virtual void setvalue(int Value);  // zmena ohodnoceni
   virtual int  getvalue();           // ziskani hodnoty
};

typedef std::set<elem_t*> elemlst_t;  // mnozina elementu

//////////////////////////////////////////////////////////////////////////////


class node_t;                                        // uzel grafu

class edge_t: public elem_t {                        // orient. hrana grafu
 protected:
   node_t *from, *to;                                // od, k uzlu
 public:
   edge_t(node_t *From, node_t *To, int Value);      // konstruktor

   virtual node_t *isfrom(node_t *From);             // test vyst. hrany...
   // ...pro From NULL vraci from, pro From from vraci to, jinak NULL

   virtual bool isfromto(node_t *From, node_t *To);  // test or. hrany
   virtual ~edge_t();                                // destruktor
};

class nedge_t: public edge_t {                       // neor. hrana grafu
 public:
   nedge_t(node_t *From, node_t *To, int Value);     // konstruktor

   virtual node_t *isfrom(node_t *From);             // test hrany...
   // ...pro From NULL vraci from, pro From from/to vraci to/from, jinak NULL

   virtual bool isfromto(node_t *From, node_t *To);  // test neor. hrany
};

typedef std::set<edge_t*> edgelst_t;                 // mnozina hran

//////////////////////////////////////////////////////////////////////////////


class node_t: public elem_t {              // uzel orientovaneho grafu
 friend class edge_t;
   edgelst_t edges;                        // seznam odkazujicich se hran
 public:
   node_t(int Value);
   edgelst_t getedges();                   // vraci kopii seznamu hran
   virtual ~node_t();                      // destruktor (rusi hrany)
};

typedef std::set<node_t*> nodelst_t;       // mnozina uzlu

//////////////////////////////////////////////////////////////////////////////


class graph_t {                                // (ne)ohodnoceny orient. graf
 protected:
   edgelst_t edges;                            // mnozina vytvorenych a hran
   nodelst_t nodes;                            // mnozina vytvorenych a uzlu
   bool isedge(node_t *From, node_t *To);      // test existence hrany
 public:
   virtual bool erase(node_t* Node, bool Edges=true);  // rusi uzel (s hranou)
   virtual void erase(edge_t* Edge);                   // zrusi hranu
   virtual node_t *insert_node(int Value=0);   // vytvoreni uzlu
   virtual edge_t *insert_edge(                // vytvoreni orientovane hrany
      node_t *From, node_t *To, bool Unique, int Value=0);
   virtual void clear();                       // zrusi vsechny elementy
   virtual ~graph_t();                         // destruktor
};

class ngraph_t: public graph_t {               // neorientovany graf
 public:
   virtual edge_t *insert_edge(                // vytvoreni n. hrany
      node_t *From, node_t *To, bool Unique, int Value=0);
};

//////////////////////////////////////////////////////////////////////////////

#endif
